/* 
-------------------------------------
-		SDAL's Music Box 2			-
-(c) by Sir Drink a lot (04.10.2005)-
-------------------------------------

This plugin allows admins to play custom sounds to all players or to a single player.
Admins must have accesslevel 512 and accesslevel 64 to use this plugin.
The admin has several options how to play the sound. He can use commands in
console, per keyword in chat or by using the menu. 

Another feature of the plugin is the Map.res Manager:
If the administrator of the server is too lazy to build up mapname.res files for each map, 
he can enable the Map.res Manager, which does automatically create it or adds missing
sounds to it. The Map.res Manager gives also a hint, if sound file does not exist on server
when you make a typo in playerlist.cfg.

* Commands:
--------------------
+ used in console:
- admin_play <number>: allows admins to play a sound to all players on server.
- admin_playto <number> <player>: allows admins to play sound to a player.
- admin_playlist <number>: displays the sound numbers in playerlist.
- admin_playmenu: opens menu with all keywords
- admin_res_manager: <0/1> enables the feature (Map.res Manager) that 
  plugin creates mapname.res files automatically. (OFF per default)
+ used in chat:
- say '.musicbox' opens menu with all keywords
- say 'keyword' '<[player]>' plays sound to all [or player]
- say '.stop' or '.play' to turn on/off customsounds

* Installation:
--------------------
- all sounds are set up in addons/adminmod/config/playlist.cfg
- sounds are played randomly enabled by keyword
- number of sounds is not restricted for one keyword
- keywords are marked with a # in front. Next line is for path/wav file
- keyword must be one word
- example:

#doh
sound/misc/doh.wav
sound/misc/doh3.wav
sound/misc/doh4.wav
sound/misc/doh5.wav
sound/misc/doh7.wav
sound/misc/doh2.wav
sound/misc/dohoo.wav

!!!IMPORTANT!!!
PLEASE USE / INSTEAD \ AND YOU NEED TO SET
THE FULL PATH STARTING WITH sound/
LAST LINE MUST BE EMPTY IN FILE!

* Needed settings:
--------------------
+ in adminmod.cfg:
- amv_enable_beta "menu1", so admin can use the playmenu.
- file_access_read 1
- file_access_write 1, if plugin shall create/edit the mapname.res file
- allow_client_exec 1
+ for the sound:
- create mapname.res files or enable Map.res Manager, that clients can download the sounds.
*/

#include <string>
#include <admin>
#include <adminlib>

new AM_VERSION_STRING[] = "2.50.60";

#define ACCESS_SOUND	512+64

new g_File[MAX_TEXT_LENGTH]="addons/adminmod/config/playlist.cfg";

//plugin_sdal_allowsound
new g_Key[]="am_sound";

//Keywords and sounds
#define MAX_KEYWORDS 50
new g_Keywords[MAX_KEYWORDS][MAX_COMMAND_LENGTH];
new g_KeyStart[MAX_KEYWORDS];
new g_loaded_keywords;

#define MAX_SOUNDS	200	
new g_Sounds[MAX_SOUNDS][MAX_TEXT_LENGTH];
new g_loaded_sounds;

//menu
#define MAIN_MENU	1
#define EXEC_MENU	2
#define PLAYER_MENU	3
#define ERR_MENU	4
#define ITEMS_PER_PAGE	7
#define NEXT	8
#define BACK	9
#define CANCEL	10

new g_UserMenu[MAX_PLAYERS];
new g_UserSelect[MAX_PLAYERS];
new g_UserSoundSelect[MAX_PLAYERS];

new g_enable_res;

public plugin_init(){
	
	if(getvar("file_access_read")){
		plugin_registerinfo("SDAL's MUSICBOX 2","Play sounds which are listed in playlist",AM_VERSION_STRING);
		plugin_registercmd("admin_play","play",ACCESS_SOUND,"admin_play <number>: plays sound which is listed under this number in playlist to all players.");
		plugin_registercmd("admin_playto","play",ACCESS_SOUND,"admin_play <number> <player>: plays sound which is listed under this number in playlist to the player.");
		plugin_registercmd("admin_playlist","playlist",ACCESS_SOUND,"admin_playlist <number>: displays all sounds which are in list.");
		plugin_registercmd("admin_res_manager","set_res",ACCESS_SOUND,"admin_res_manager <0/1>: plugin manages and creates mapname.res files on server.");
		plugin_registercmd("say","HandleSay",ACCESS_ALL);
		plugin_registercmd("say_team","HandleSay",ACCESS_ALL);
		plugin_registerhelp("say",ACCESS_ALL,"say '.stop': disables the custom sounds for you");
		plugin_registerhelp("say",ACCESS_ALL,"say '.play': enables the custom sounds for you");
		read_file();
		get_vaultnumdata("MUSICBOX_RES_MANAGER",g_enable_res);
		if(g_enable_res && getvar("file_access_write")){
			new MapName[MAX_NAME_LENGTH];
			currentmap(MapName,MAX_NAME_LENGTH);
			check_res(MapName);
		}
		new menu_enabled[MAX_NAME_LENGTH];
		getstrvar("amv_enable_beta",menu_enabled,MAX_NAME_LENGTH);
		if(strstrx(menu_enabled,"menu1")!=-1){
			plugin_registercmd("admin_playmenu","playmenu",ACCESS_SOUND,"admin_playmenu: opens the musicbox menu");
			plugin_registerhelp("say",ACCESS_SOUND,"say '.musicbox': opens the musicbox menu for you");
			plugin_registercmd("menuselect","menuselect",ACCESS_ALL);
			plugin_registercmd("radio1","SetMenuData",ACCESS_ALL);
			plugin_registercmd("radio2","SetMenuData",ACCESS_ALL);
			plugin_registercmd("radio3","SetMenuData",ACCESS_ALL);
			plugin_registercmd("buyequip","SetMenuData",ACCESS_ALL);
			plugin_registercmd("buy","SetMenuData",ACCESS_ALL);
			plugin_registercmd("chooseteam","SetMenuData",ACCESS_ALL);
			plugin_registercmd("showbriefing","SetMenuData",ACCESS_ALL);
		}else{
			selfmessage("[SDAL's MUSICBOX] Menu is not enabled. Please set amv_enable_beta ^"menu1^" in adminmod.cfg");
		}
	}else{
		plugin_registerinfo("SDAL's MUSICBOX 2","PLUGIN DISABLED! file_access_read not set to 1 in adminmod.cfg!!",AM_VERSION_STRING);
	}
	return PLUGIN_CONTINUE;
}

/////////////////////////////////
// read data from playlist.cfg //
/////////////////////////////////
read_file(){
	new Data[MAX_DATA_LENGTH];
	new iFileSize;
	new i;
	if(fileexists(g_File)){
		iFileSize = filesize(g_File);
		for(i=1;i<=iFileSize;i++){
			readfile(g_File,Data,i,MAX_DATA_LENGTH);
			//split data in keyword and sound
			if(strlen(Data)!=0){
				if(strncmp(Data,"#",1)==0){
					strsubst(Data,"#","",MAX_DATA_LENGTH);
					strcpy(g_Keywords[g_loaded_keywords],Data,MAX_COMMAND_LENGTH);
					g_KeyStart[g_loaded_keywords]=g_loaded_sounds;
					g_loaded_keywords++;
					if(g_loaded_keywords>=MAX_KEYWORDS){
						selfmessage("[SDAL'S MUSICBOX] To many keywords in playlist.cfg! Increase MAX_KEYWORDS in plugin_sdal_musicbox.sma and recompile!");
						break;
					}
				}else{
					strcpy(g_Sounds[g_loaded_sounds],Data,MAX_TEXT_LENGTH);
					g_loaded_sounds++;
					if(strncmp(Data,"sound/",6)==0 && !fileexists(Data)){
						snprintf(Data,MAX_DATA_LENGTH,"[Map.res Manager] HINT: ^"%s^" can't be found on server. Maybe clients don't have it and can't download it!",Data);
						selfmessage(Data);
					}
					if(g_loaded_sounds>=MAX_SOUNDS){
						selfmessage("[SDAL'S MUSICBOX] To many sounds in playlist.cfg! Increase MAX_SOUNDS in plugin_sdal_musicbox.sma and recompile!");
						break;
					}
				}
			}
		}
		g_KeyStart[g_loaded_keywords]=g_loaded_sounds-1;
		g_loaded_keywords--;
		g_loaded_sounds--;
	}else{
		snprintf(Data,MAX_DATA_LENGTH,"[SDAL'S MUSICBOX] ^"%s^" not found!",g_File);
		selfmessage(Data);
	}
}

/////////////////////
// Map.res Manager //	
/////////////////////

// turn on/off map.res manager
public set_res(HLCommand,HLData,HLUserName,UserIndex){
	new Text[MAX_TEXT_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new iData;
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	
	if(strlen(Data)!=0){
		iData=strtonum(Data);
		if(iData>0){
			g_enable_res=1;
		}else{
			g_enable_res=0;
		}
		set_vaultnumdata("MUSICBOX_RES_MANAGER",g_enable_res);
	}
	
	snprintf(Text,MAX_TEXT_LENGTH,"[SDAL'S MUSICBOX] Map.res Manager is set to %i! (1=enabled, 0=disabled)",g_enable_res);	
	selfmessage(Text);
	return PLUGIN_HANDLED;
}

// create/edit map.res file
check_res(MapName[]){
	new Data[MAX_DATA_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new Found[MAX_SOUNDS];
	new iFileSize;
	new i;
	new j;
	snprintf(Text,MAX_TEXT_LENGTH,"maps/%s.res",MapName);
	if(!fileexists(Text)){
		snprintf(Data,MAX_DATA_LENGTH,"[SDAL's MUSICBOX] Create new file. Adding sounds to %s:",Text);
		selfmessage(Data);
		for(i=0;i<=g_loaded_sounds;i++){
			if(strncmp(g_Sounds[i],"sound/",6)==0){
				writefile(Text,g_Sounds[i],-1);
				snprintf(Data,MAX_DATA_LENGTH,"[SDAL's MUSICBOX] - %s",g_Sounds[i]);
				selfmessage(Data);
			}
		}
	}else{
		iFileSize=filesize(Text);
		snprintf(Data,MAX_DATA_LENGTH,"[SDAL's MUSICBOX] File exists. Compare and adding sounds to %s:",Text);
		selfmessage(Data);
		for(i=0;i<=iFileSize;i++){
			strinit(Data);
			readfile(Text,Data,i,MAX_DATA_LENGTH);
			if(strlen(Data)!=0 && strncmp(Data,"sound/",6)==0){
				for(j=0;j<=g_loaded_sounds;j++){
					if(strcmp(Data,g_Sounds[j])==0){
						Found[j]=1;
						break;
					}
				}
			}
		}
		
		for(i=0;i<=g_loaded_sounds;i++){
			if(!Found[i] && strncmp(g_Sounds[i],"sound/",6)==0){
				writefile(Text,g_Sounds[i],-1);
				snprintf(Data,MAX_DATA_LENGTH,"[SDAL's MUSICBOX] - %s",g_Sounds[i]);
				selfmessage(Data);
			}
		}
	}
}

/////////////////////////////////////////
// check all say messages for keywords //
/////////////////////////////////////////
public HandleSay(HLCommand,HLData,HLUserName,UserIndex) {
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	new Key[MAX_NAME_LENGTH];
	new Player[MAX_NAME_LENGTH];
	new i;
	new j;
	new x;
	new iNumber;
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	strstripquotes(Data);
	if(strcmp(Data,".stop")==0){
		set_key(User,0);
		return PLUGIN_HANDLED;
	}else if(strcmp(Data,".play")==0){
		set_key(User,1);
	}else if(access(ACCESS_SOUND)){
		strsep(Data," ",Key,MAX_NAME_LENGTH,Player,MAX_NAME_LENGTH);
		if(strcmp(Key,".musicbox")==0){
			main_menu(User,UserIndex);
			return PLUGIN_HANDLED;
		}else{
			for(i=0;i<=g_loaded_keywords;i++){
				if(strcmp(Key,g_Keywords[i])==0){
					for(j=g_KeyStart[i];j<g_KeyStart[i+1];j++){
						x++;
					}
					iNumber=random(x)+g_KeyStart[i];
					check_data(iNumber,Player);
					return PLUGIN_HANDLED;
					break;
				}
			}
		}
	}
	return PLUGIN_CONTINUE;
}

////////////////////////////////////////////////////
// turn on/off customsounds for individual player //
////////////////////////////////////////////////////
allowsound(User[]){
	new Info[MAX_NUMBER_LENGTH];
	new iInfo;
	new Authid[MAX_AUTHID_LENGTH];
	get_userAuthID(User,Authid,MAX_AUTHID_LENGTH);
	if(strcmp(Authid,"BOT")!=0){
		get_userinfo(User,g_Key,Info,MAX_NUMBER_LENGTH);
		iInfo=strtonum(Info);
		if(strlen(Info)==0 || iInfo >=1){/*damit wird automatisch immer der Sound auf 1 gesetzt,wenn kein setinfo vorhanden, bis 'stop' eingegeben wird*/
			return 1;
		}
	}
	return 0;
}

set_key(User[],iValue){
	new Text[MAX_TEXT_LENGTH];
	new sInfo[MAX_TEXT_LENGTH];
	if(iValue){
		snprintf(Text,MAX_TEXT_LENGTH,"[SDAL's MUSICBOX] You have enabled the custom sounds. Use '.stop' if you want to turn them off again.");
		snprintf(sInfo,MAX_TEXT_LENGTH,"setinfo ^"%s^" ^"1^"",g_Key);
	}else{
		snprintf(Text,MAX_TEXT_LENGTH,"[SDAL's MUSICBOX] You have disabled the custom sounds. Use '.play' if you want to enable them again.");
		snprintf(sInfo,MAX_TEXT_LENGTH,"setinfo ^"%s^" ^"0^"",g_Key);
	}		
	messageex(User,Text,print_chat);
	execclient(User,sInfo);
}

///////////////////////////
// play sound to players //
///////////////////////////
public play(HLCommand,HLData,HLUserName,UserIndex){
	new Data[MAX_DATA_LENGTH];
	new Number[MAX_NUMBER_LENGTH];
	new Player[MAX_NAME_LENGTH];
	new iNumber;
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	strsep(Data," ",Number,MAX_NUMBER_LENGTH,Player,MAX_NAME_LENGTH);
	iNumber=strtonum(Data);
	check_data(iNumber,Player);
	return PLUGIN_HANDLED;
}

check_data(iNumber,Player[]){
	new Data[MAX_DATA_LENGTH];
	if(0 <= iNumber <=g_loaded_sounds){
		if(strlen(g_Sounds[iNumber])!=0){
			if(strlen(Player)!=0){
				if (check_user(Player)) {
					get_username(Player,Player,MAX_NAME_LENGTH);
					if(allowsound(Player)){
						play_to(g_Sounds[iNumber],Player);
						snprintf(Data,MAX_DATA_LENGTH,"[SDAL'S MUSICBOX] '%s' is played to %s!",g_Sounds[iNumber],Player);
					}else{
						snprintf(Data,MAX_DATA_LENGTH,"[SDAL'S MUSICBOX] %s has disabled custom sounds!",Player);
					}
				}else{
					snprintf(Data,MAX_DATA_LENGTH,"[SDAL'S MUSICBOX] Player %s could not be found!",Player);
				}
			}else{
				sound_all(g_Sounds[iNumber]);
				snprintf(Data,MAX_DATA_LENGTH,"[SDAL'S MUSICBOX] '%s' is played to all players!",g_Sounds[iNumber]);
			}
		}else{
			snprintf(Data,MAX_DATA_LENGTH,"[SDAL'S MUSICBOX] Sound not found!");
		}
	}else{
		snprintf(Data,MAX_DATA_LENGTH,"[SDAL'S MUSICBOX] Number is invalid!");
	}
	selfmessage(Data);	
}

sound_all(Sound[]){
	new Name[MAX_NAME_LENGTH];
	new maxplayers = maxplayercount();
	new i;
	for(i=1;i<=maxplayers;i++ ){
		if(playerinfo(i, Name, MAX_NAME_LENGTH) ){
			if(allowsound(Name)){
				play_to(Sound,Name);
			}
		}
	}
		
}

play_to(Sound[],Player[]){
	new Data[MAX_DATA_LENGTH];
	snprintf(Data,MAX_DATA_LENGTH, "speak %s", Sound);
	execclient(Player,Data);
}

//////////////////////////////////
// display soundlist in console //
//////////////////////////////////
public playlist(HLCommand,HLData,HLUserName,UserIndex){
	new Data[MAX_DATA_LENGTH];
	new iData;
	convert_string(HLData,Data,MAX_DATA_LENGTH);

	iData=strtonum(Data);
	if(iData> g_loaded_sounds || iData <= 0){
		iData=0;
	}
	play_list(iData);
	return PLUGIN_HANDLED;
}

play_list(iID){
	new Text[MAX_TEXT_LENGTH];
	new i;
	new x;
	new imax;
	selfmessage("**********************************");
	selfmessage("* SDAL's MUSICBOX");
	selfmessage("* --- playlist: ---");
	imax = iID + 9;
	if(imax>=g_loaded_sounds){
		imax=g_loaded_sounds;
	}
	
	for(x=0;x<=g_loaded_keywords;x++){
		if(g_KeyStart[x]>=iID){
			break;
		}
	}
	
	for(i=iID;i<=imax;i++){
		if(g_KeyStart[x]==i){
			snprintf(Text,MAX_TEXT_LENGTH,"[%s]",g_Keywords[x]);
			selfmessage(Text);
			x++;
		}
		snprintf(Text,MAX_TEXT_LENGTH,"* %i. %s",i,g_Sounds[i]);
		selfmessage(Text);
	}
	selfmessage("**********************************");
	snprintf(Text,MAX_TEXT_LENGTH,"* Entries %i - %i of %i sounds",iID,imax,g_loaded_sounds);
	selfmessage(Text);
	selfmessage("* use admin_playlist <number> for more entries.");
	selfmessage("**********************************");
}

/////////////////
// menu display//
/////////////////
public playmenu(HLCommand,HLData,HLUserName,UserIndex){
	new User[MAX_NAME_LENGTH];
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	main_menu(User,UserIndex);
	return PLUGIN_HANDLED;
}

main_menu(User[],UserIndex){
	new Text[512];
	new keys=0;
	new key=1;
	new i;
	new x;
	
	g_UserMenu[UserIndex]=MAIN_MENU;
	
	snprintf(Text,MAX_TEXT_LENGTH,"\w[SDAL's MUSICBOX]");
	for(i=g_UserSelect[UserIndex];i<g_loaded_keywords;i++){
		x++;
		if(x>ITEMS_PER_PAGE){
			break;
		}else{
			snprintf(Text,512,"%s^n\y%i. %s",Text,x,g_Keywords[i]);
			keys |= key;
			key <<= 1;
		}
	}
	if(g_UserSelect[UserIndex] + ITEMS_PER_PAGE < g_loaded_keywords){
		if(g_UserSelect[UserIndex]==0){
			strcat(Text,"\w^n8. Next",512);
			keys+=128;
		}else{
			strcat(Text,"\w^n8. Next - 9. Back",512);
			keys+=384;
		}
	}else if(g_UserSelect[UserIndex] + ITEMS_PER_PAGE >= g_loaded_keywords && g_UserSelect[UserIndex]!=0){
		strcat(Text,"\w^n9. Back",512);
		keys+=256;
	}
	strcat(Text,"\r^n0. Cancel",512);
	keys+=512;
	menu(User,Text,keys);
}

second_menu(User[],UserIndex){
	new Text[512];
	
	g_UserMenu[UserIndex]=EXEC_MENU;
	
	snprintf(Text,512,"\w[SDAL's MUSICBOX]^nPlay '%s' to^n\y1. all players^n2. a player^n\r0.Cancel",g_Keywords[g_UserSoundSelect[UserIndex]]);
	menu(User,Text,515);
}

player_menu(User[],UserIndex){
	new Text[512];
	new Player[MAX_NAME_LENGTH];
	new keys=0;
	new key=1;
	new i;
	new x;
	new maxplayers=maxplayercount();
	new players=playercount();
	
	g_UserMenu[UserIndex]=PLAYER_MENU;
	
	snprintf(Text,MAX_TEXT_LENGTH,"\w[SDAL's MUSICBOX]^nPlay '%s' to:",g_Keywords[g_UserSoundSelect[UserIndex]]);
	for(i=g_UserSelect[UserIndex];i<=maxplayers;i++){
		if(playerinfo(i,Player,MAX_NAME_LENGTH)){
			x++;
			if(x>ITEMS_PER_PAGE){
				break;
			}else{
				snprintf(Text,512,"%s^n\y%i. %s",Text,x,Player);
				keys |= key;
				key <<= 1;
			}
		}
	}
	if(g_UserSelect[UserIndex] + ITEMS_PER_PAGE < players){
		if(g_UserSelect[UserIndex]==1){
			strcat(Text,"\w^n8. Next",512);
			keys+=128;
		}else{
			strcat(Text,"\w^n8. Next - 9. Back",512);
			keys+=384;
		}
	}else if(g_UserSelect[UserIndex] + ITEMS_PER_PAGE >= players && g_UserSelect[UserIndex]!=1){
		strcat(Text,"\w^n9. Back",512);
		keys+=256;
	}
	strcat(Text,"\r^n0. Cancel",512);
	keys+=512;
	menu(User,Text,keys);
}
	

public menuselect(HLCommand,HLData,HLUserName,UserIndex){
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	new iSelect;
  	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	if(g_UserMenu[UserIndex]!=0){
		iSelect=strtonum(Data);
		if(iSelect==NEXT){ 	
			g_UserSelect[UserIndex]=g_UserSelect[UserIndex]+ITEMS_PER_PAGE;
			if(g_UserMenu[UserIndex]==MAIN_MENU){
				main_menu(User,UserIndex);
			}else{
				player_menu(User,UserIndex);
			}
		}else if(iSelect==BACK){
			g_UserSelect[UserIndex]=g_UserSelect[UserIndex]-ITEMS_PER_PAGE;
			if(g_UserMenu[UserIndex]==MAIN_MENU){
				main_menu(User,UserIndex);
			}else{
				player_menu(User,UserIndex);
			}
		}else if(iSelect==CANCEL){
			if(g_UserMenu[UserIndex]==PLAYER_MENU){
				g_UserSelect[UserIndex]=0;
				second_menu(User,UserIndex);
			}else if(g_UserMenu[UserIndex]==EXEC_MENU){
				g_UserSelect[UserIndex]=0;
				main_menu(User,UserIndex);
			}else{
				reset_array(UserIndex);
			}
		}else if(g_UserMenu[UserIndex]==MAIN_MENU){
			g_UserSoundSelect[UserIndex]=g_UserSelect[UserIndex]+iSelect-1;
			second_menu(User,UserIndex);
		}else if(g_UserMenu[UserIndex]==EXEC_MENU){
			if(iSelect==1){
				snprintf(Data,MAX_DATA_LENGTH,"say %s",g_Keywords[g_UserSoundSelect[UserIndex]]);
				execclient(User,Data);
				main_menu(User,UserIndex);
			}else if(iSelect==2){
				g_UserSelect[UserIndex]=1;
				player_menu(User,UserIndex);
			}
		}else if(g_UserMenu[UserIndex]==PLAYER_MENU){
			new Player[MAX_NAME_LENGTH];
			if(playerinfo(iSelect+g_UserSelect[UserIndex]-1,Player,MAX_NAME_LENGTH)){
				snprintf(Data,MAX_DATA_LENGTH,"say %s %s",g_Keywords[g_UserSoundSelect[UserIndex]],Player);
				execclient(User,Data);
			}
			player_menu(User,UserIndex);
		}
	}
	return PLUGIN_CONTINUE;
}
			

//menu closed by another menu 
public SetMenuData(HLCommand,HLData,HLUserName,UserIndex){
	new UserName[MAX_NAME_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	convert_string(HLUserName,UserName,MAX_NAME_LENGTH);
	if(g_UserMenu[UserIndex]!=0){
		reset_array(UserIndex);
		snprintf(Text,MAX_TEXT_LENGTH,"[SDAL'S MUSICBOX] Menu is closed by another menu!");
		messageex(UserName,Text,print_chat);
	}
	return PLUGIN_CONTINUE;
}

//player connects or disconnects. reset menu
public plugin_disconnect(HLUserName,UserIndex) {
	if(1 <= UserIndex <= MAX_PLAYERS){
		reset_array(UserIndex);
	}
	return PLUGIN_CONTINUE;
}
	
public plugin_connect(HLUserName,HLIP, UserIndex) {
	if(1 <= UserIndex <= MAX_PLAYERS){
		reset_array(UserIndex);
	}
	return PLUGIN_CONTINUE;
}

//reset all data of user
reset_array(UserIndex){
	g_UserMenu[UserIndex]=0;
	g_UserSelect[UserIndex]=0;
}
